/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.battle.Fighter
 *  fire.pb.effect.Module
 *  fire.pb.util.Parser
 */
package fire.script;

import fire.pb.battle.Fighter;
import fire.pb.util.Parser;
import fire.script.AbstractJSEngine;
import fire.script.JsFunManager;
import fire.script.Module;
import java.util.List;

public class JavaScript {
    private String js;
    private Double value = null;
    private int funID = -1;

    public static boolean isNumeric(String str) {
        int i = str.length();
        while (--i >= 0) {
            if (Character.isDigit(str.charAt(i)) || str.charAt(i) == '.' || str.charAt(i) == '-') continue;
            return false;
        }
        return true;
    }

    public boolean isFun() {
        return this.value == null;
    }

    public Double GetDoubleValue() {
        return this.value;
    }

    public int GetfunID() {
        return this.funID;
    }

    public void SetfunID(int funID) {
        this.funID = funID;
    }

    public JavaScript(String js) {
        if (JavaScript.isNumeric(js)) {
            this.value = Double.valueOf(js);
        } else {
            this.js = "with(Math){ return " + js + ";}";
            this.funID = JsFunManager.GetFunID(this.js);
        }
    }

    public JavaScript(String js, boolean neednoreturn) {
        if (JavaScript.isNumeric(js)) {
            this.value = Double.valueOf(js);
        } else {
            this.js = "with(Math){ " + js + ";}";
            this.funID = JsFunManager.GetFunID(this.js);
        }
    }

    public Double eval(AbstractJSEngine engine, Fighter opf, Fighter aimf) {
        try {
            if (this.value != null) {
                return this.value;
            }
            Object o = null;
            o = this.funID > -1 ? JsFunManager.JsFunbyID(engine, opf, aimf, this.funID) : engine.eval(this.js);
            if (o == null) {
                return null;
            }
            if (o instanceof Float) {
                return ((Float)o).doubleValue();
            }
            if (o instanceof Double) {
                return (Double)o;
            }
            if (o instanceof Integer) {
                return ((Integer)o).doubleValue();
            }
            if (o instanceof Long) {
                return ((Long)o).doubleValue();
            }
            if (o instanceof Boolean) {
                return (Boolean)o == true ? 1.0 : 0.0;
            }
            AbstractJSEngine.logger.error((Object)("JS脚本" + this.js + "有错：/n"));
            return 0.0;
        }
        catch (Exception e) {
            AbstractJSEngine.logger.error((Object)("JS脚本" + this.js + "有错：/n" + Parser.convertStackTrace2String((Exception)e)));
            return 0.0;
        }
    }

    public Boolean evalToBoolean(AbstractJSEngine engine, Fighter opf, Fighter aimf) {
        try {
            if (this.value != null) {
                return this.value.intValue() != 0;
            }
            Object o = null;
            o = this.funID > -1 ? JsFunManager.JsFunbyID(engine, opf, aimf, this.funID) : engine.eval(this.js);
            if (o == null) {
                return false;
            }
            if (o instanceof Boolean) {
                return (Boolean)o;
            }
            if (o instanceof Integer) {
                return (Integer)o != 0;
            }
            if (o instanceof Long) {
                return (Long)o != 0L;
            }
            AbstractJSEngine.logger.error((Object)("JS脚本" + this.js + "有错：/n"));
            return false;
        }
        catch (Exception e) {
            AbstractJSEngine.logger.error((Object)("JS脚本" + this.js + "有错：/n" + Parser.convertStackTrace2String((Exception)e)));
            return false;
        }
    }

    public String getJavaScriptString() {
        return this.js;
    }

    public String toString() {
        return this.js;
    }

    public String getOringinString() {
        return this.js.substring(11, this.js.length() - 1);
    }

    public JavaScript append(String episode) {
        StringBuffer sb = new StringBuffer(this.js);
        sb.insert(sb.length() - 1, episode);
        this.js = sb.toString();
        return this;
    }

    public void parseUsedAttrTypes(List<Integer> usedattrtypea, List<Integer> usedattrtypeb) {
        try {
            if (this.value == null) {
                String name;
                int i;
                if (this.funID > -1) {
                    return;
                }
                for (i = 0; i < fire.pb.effect.Module.fightAttrTypeIds.length; ++i) {
                    name = fire.pb.effect.Module.getInstance().getEffectNameById(fire.pb.effect.Module.fightAttrTypeIds[i]);
                    if (this.js.contains(name + "a") && !usedattrtypea.contains(fire.pb.effect.Module.fightAttrTypeIds[i])) {
                        usedattrtypea.add(fire.pb.effect.Module.fightAttrTypeIds[i]);
                    }
                    if (!this.js.contains(name + "b") || usedattrtypeb.contains(fire.pb.effect.Module.fightAttrTypeIds[i])) continue;
                    usedattrtypeb.add(fire.pb.effect.Module.fightAttrTypeIds[i]);
                }
                for (i = 0; i < fire.pb.effect.Module.extfightAttrTypeIds.length; ++i) {
                    name = fire.pb.effect.Module.getInstance().getEffectNameById(fire.pb.effect.Module.extfightAttrTypeIds[i]);
                    if (this.js.contains(name + "a") && !usedattrtypea.contains(fire.pb.effect.Module.extfightAttrTypeIds[i])) {
                        usedattrtypea.add(fire.pb.effect.Module.extfightAttrTypeIds[i]);
                    }
                    if (!this.js.contains(name + "b") || usedattrtypeb.contains(fire.pb.effect.Module.extfightAttrTypeIds[i])) continue;
                    usedattrtypeb.add(fire.pb.effect.Module.extfightAttrTypeIds[i]);
                }
                Module.registerJavaScriptExpr(this.js, true, null);
            }
        }
        catch (Exception e) {
            e.printStackTrace();
        }
    }
}

